package remulakjava;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import java.rmi.RemoteException;
import java.util.Properties;
import javax.ejb.CreateException;
import javax.ejb.RemoveException;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;

public class RemulakServlet extends HttpServlet {

    /**
     * Creates an EmployeeRegistryBean and a NewsBean, and saves them
     * as servlet context attributes.
     */
    public void init() throws ServletException {
    }

    public void destroy() {
   /*     getServletContext().removeAttribute("empReg");
        getServletContext().removeAttribute("news");
        */
    }

    /**
     * Processes a GET request by calling doPost().
     */
    public void doGet(HttpServletRequest request,
        HttpServletResponse response)
        throws IOException, ServletException {
        doPost(request, response);
    }

    /**
     * Performs authentication, if needed, and access control.
     * If the user is authorized, performs the action specified by
     * the "action" request parameter.
     */
    public void doPost(HttpServletRequest request,
        HttpServletResponse response)
        throws IOException, ServletException {

        String action = request.getParameter("action");

        // Check which action to do and forward to it
        if ("rltnInquiry".equals(action)) {
                doRltnInquiry(request, response);
         }
         /**
        else if ("rltnAdd".equals(action)) {
                doRltnAdd(request, response);
        }
        else if ("rltnUpdate".equals(action)) {
                doRltnUpdate(request, response);
        }
        else if ("orderInquiry".equals(action)) {
                doOrderInquiry(request, response);
        }
        else if ("orderAdd".equals(action)) {
                doOrderAdd(request, response);
        }
        else if ("orderUpdate".equals(action)) {
                doOrderUpdate(request, response);
        }
        */
        else {
                response.sendError(HttpServletResponse.SC_NOT_IMPLEMENTED);
        }
     }

     /**
     * This operation represents the relationship inquiry pathway through
     * the Maintain Relationships Use Case
     */
     private void doRltnInquiry(HttpServletRequest request,
        HttpServletResponse response)
        throws IOException, ServletException {

        String customerNumber = request.getParameter("customerNumber");
        if (customerNumber == null) {
                throw new ServletException("Missing message info");
        }

        /**
        * Call the EJB Session Bean to retrieve the objects to display
        */

        private UCMaintainRltnshpHome home;
        private CustomerValue custVal;

        home = lookupHome();

        UCMaintainRltnshp UCController =
             (UCMaintainRltnshp) narrow(home.create(), UCMaintainRltnshp.class);

        UCController.rltnInquiry(custVal);

        // remove the UCMaintainRltnshp Controller
        log("Removing the trader");
        UCController.remove();
    }



        /**
        * Forward to the JSP page used to actually display the page
        */

        forward("rltnInquiry.jsp", request, response);
    }

    /**
    * RMI/IIOP clients should use this narrow function
    */
    private Object narrow(Object ref, Class c) {
       return PortableRemoteObject.narrow(ref, c);
    }

    /**
    * Lookup the EJBs home in the JNDI tree
    */
    private UCMaintainRltnshpHome lookupHome()
    throws NamingException {
    // Lookup the beans home using JNDI
    Context ctx = getInitialContext();

    try {
      Object home = ctx.lookup(JNDI_NAME);
      return (UCMaintainRltnshpHome) narrow(home, UCMaintainRltnshpHome.class);
      } catch (NamingException ne) {
        log("The client was unable to lookup the EJBHome.  Please make sure ");
        log("that you have deployed the ejb with the JNDI name "+JNDI_NAME+" on the WebLogic server at "+url);
        throw ne;
      }
    }

    /**
    * Using a Properties object will work on JDK 1.1.x and Java2
    * clients
    */
   private Context getInitialContext() throws NamingException {

    try {
      // Get an InitialContext
      Properties h = new Properties();
      h.put(Context.INITIAL_CONTEXT_FACTORY,
        "weblogic.jndi.WLInitialContextFactory");
      h.put(Context.PROVIDER_URL, url);
      return new InitialContext(h);
    } catch (NamingException ne) {
      log("We were unable to get a connection to the WebLogic server at "+url);
      log("Please make sure that the server is running.");
      throw ne;
    }
   }

    /**
     * Forwards the request to the specified relative URL.
     */
    private void forward(String url, HttpServletRequest request,
        HttpServletResponse response)
        throws IOException, ServletException {
        RequestDispatcher rd = request.getRequestDispatcher(url);
        rd.forward(request, response);
    }
    private static void log(String s) {
    System.out.println(s);
    }

}